using System.Linq;
using Magify.Model;

namespace Magify
{
    public static class CampaignExtensions
    {
        internal static bool IsSupportNested(this ICampaign campaign)
        {
            return campaign.Type.IsSupportNested() is true;
        }

        internal static bool TryGetNested(this CampaignRequest campaignRequest, string productId, out NestedCampaign result)
        {
            result = campaignRequest.NestedCampaigns?.FirstOrDefault(p => p.ProductId == productId);
            return result != null;
        }
    }
}